import decimal
import java.lang
import java.math
import java.util.function
import org.optaplanner.core.api.function
import org.optaplanner.core.api.score
import org.optaplanner.core.api.score.stream
import org.optaplanner.core.api.score.stream.bi
import org.optaplanner.core.api.score.stream.quad
import org.optaplanner.core.api.score.stream.uni
import typing



_TriConstraintCollector__A = typing.TypeVar('_TriConstraintCollector__A')  # <A>
_TriConstraintCollector__B = typing.TypeVar('_TriConstraintCollector__B')  # <B>
_TriConstraintCollector__C = typing.TypeVar('_TriConstraintCollector__C')  # <C>
_TriConstraintCollector__ResultContainer_ = typing.TypeVar('_TriConstraintCollector__ResultContainer_')  # <ResultContainer_>
_TriConstraintCollector__Result_ = typing.TypeVar('_TriConstraintCollector__Result_')  # <Result_>
class TriConstraintCollector(typing.Generic[_TriConstraintCollector__A, _TriConstraintCollector__B, _TriConstraintCollector__C, _TriConstraintCollector__ResultContainer_, _TriConstraintCollector__Result_]):
    """
    public interface TriConstraintCollector<A, B, C, ResultContainer_, Result_>
    
        Usually created with :class:`~org.optaplanner.core.api.score.stream.ConstraintCollectors`. Used by
        :meth:`~org.optaplanner.core.api.score.stream.tri.TriConstraintStream.groupBy`, ...
    
        Loosely based on JDK's
        :class:`~org.optaplanner.core.api.score.stream.tri.https:.docs.oracle.com.javase.8.docs.api.java.util.stream.Collector?is`,
        but it returns an undo operation for each accumulation to enable incremental score calculation in
        :class:`~org.optaplanner.core.api.score.stream.ConstraintStream`.
    
        Also see:
            :class:`~org.optaplanner.core.api.score.stream.ConstraintCollectors`
    """
    def accumulator(self) -> org.optaplanner.core.api.function.QuadFunction[_TriConstraintCollector__ResultContainer_, _TriConstraintCollector__A, _TriConstraintCollector__B, _TriConstraintCollector__C, java.lang.Runnable]: ...
    def finisher(self) -> java.util.function.Function[_TriConstraintCollector__ResultContainer_, _TriConstraintCollector__Result_]: ...
    def supplier(self) -> java.util.function.Supplier[_TriConstraintCollector__ResultContainer_]: ...

_TriConstraintStream__A = typing.TypeVar('_TriConstraintStream__A')  # <A>
_TriConstraintStream__B = typing.TypeVar('_TriConstraintStream__B')  # <B>
_TriConstraintStream__C = typing.TypeVar('_TriConstraintStream__C')  # <C>
class TriConstraintStream(org.optaplanner.core.api.score.stream.ConstraintStream, typing.Generic[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]):
    """
    public interface TriConstraintStream<A, B, C> extends :class:`~org.optaplanner.core.api.score.stream.ConstraintStream`
    
        A :class:`~org.optaplanner.core.api.score.stream.ConstraintStream` that matches three facts.
    
        Also see:
            :class:`~org.optaplanner.core.api.score.stream.ConstraintStream`
    """
    def distinct(self) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    def filter(self, triPredicate: typing.Union[org.optaplanner.core.api.function.TriPredicate[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], bool]]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    _flattenLast__ResultC_ = typing.TypeVar('_flattenLast__ResultC_')  # <ResultC_>
    def flattenLast(self, function: typing.Union[java.util.function.Function[_TriConstraintStream__C, typing.Union[java.lang.Iterable[_flattenLast__ResultC_], typing.Sequence[_flattenLast__ResultC_], typing.Set[_flattenLast__ResultC_]]], typing.Callable[[_TriConstraintStream__C], typing.Union[java.lang.Iterable[_flattenLast__ResultC_], typing.Sequence[_flattenLast__ResultC_], typing.Set[_flattenLast__ResultC_]]]]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _flattenLast__ResultC_]: ...
    _groupBy_0__GroupKeyA_ = typing.TypeVar('_groupBy_0__GroupKeyA_')  # <GroupKeyA_>
    _groupBy_0__GroupKeyB_ = typing.TypeVar('_groupBy_0__GroupKeyB_')  # <GroupKeyB_>
    _groupBy_1__GroupKey_ = typing.TypeVar('_groupBy_1__GroupKey_')  # <GroupKey_>
    _groupBy_1__ResultContainer_ = typing.TypeVar('_groupBy_1__ResultContainer_')  # <ResultContainer_>
    _groupBy_1__Result_ = typing.TypeVar('_groupBy_1__Result_')  # <Result_>
    _groupBy_2__ResultContainerA_ = typing.TypeVar('_groupBy_2__ResultContainerA_')  # <ResultContainerA_>
    _groupBy_2__ResultA_ = typing.TypeVar('_groupBy_2__ResultA_')  # <ResultA_>
    _groupBy_2__ResultContainerB_ = typing.TypeVar('_groupBy_2__ResultContainerB_')  # <ResultContainerB_>
    _groupBy_2__ResultB_ = typing.TypeVar('_groupBy_2__ResultB_')  # <ResultB_>
    _groupBy_3__GroupKeyA_ = typing.TypeVar('_groupBy_3__GroupKeyA_')  # <GroupKeyA_>
    _groupBy_3__GroupKeyB_ = typing.TypeVar('_groupBy_3__GroupKeyB_')  # <GroupKeyB_>
    _groupBy_3__GroupKeyC_ = typing.TypeVar('_groupBy_3__GroupKeyC_')  # <GroupKeyC_>
    _groupBy_3__GroupKeyD_ = typing.TypeVar('_groupBy_3__GroupKeyD_')  # <GroupKeyD_>
    _groupBy_4__GroupKeyA_ = typing.TypeVar('_groupBy_4__GroupKeyA_')  # <GroupKeyA_>
    _groupBy_4__GroupKeyB_ = typing.TypeVar('_groupBy_4__GroupKeyB_')  # <GroupKeyB_>
    _groupBy_4__GroupKeyC_ = typing.TypeVar('_groupBy_4__GroupKeyC_')  # <GroupKeyC_>
    _groupBy_4__ResultContainerD_ = typing.TypeVar('_groupBy_4__ResultContainerD_')  # <ResultContainerD_>
    _groupBy_4__ResultD_ = typing.TypeVar('_groupBy_4__ResultD_')  # <ResultD_>
    _groupBy_5__GroupKeyA_ = typing.TypeVar('_groupBy_5__GroupKeyA_')  # <GroupKeyA_>
    _groupBy_5__GroupKeyB_ = typing.TypeVar('_groupBy_5__GroupKeyB_')  # <GroupKeyB_>
    _groupBy_5__ResultContainerC_ = typing.TypeVar('_groupBy_5__ResultContainerC_')  # <ResultContainerC_>
    _groupBy_5__ResultC_ = typing.TypeVar('_groupBy_5__ResultC_')  # <ResultC_>
    _groupBy_5__ResultContainerD_ = typing.TypeVar('_groupBy_5__ResultContainerD_')  # <ResultContainerD_>
    _groupBy_5__ResultD_ = typing.TypeVar('_groupBy_5__ResultD_')  # <ResultD_>
    _groupBy_6__GroupKey_ = typing.TypeVar('_groupBy_6__GroupKey_')  # <GroupKey_>
    _groupBy_6__ResultContainerB_ = typing.TypeVar('_groupBy_6__ResultContainerB_')  # <ResultContainerB_>
    _groupBy_6__ResultB_ = typing.TypeVar('_groupBy_6__ResultB_')  # <ResultB_>
    _groupBy_6__ResultContainerC_ = typing.TypeVar('_groupBy_6__ResultContainerC_')  # <ResultContainerC_>
    _groupBy_6__ResultC_ = typing.TypeVar('_groupBy_6__ResultC_')  # <ResultC_>
    _groupBy_6__ResultContainerD_ = typing.TypeVar('_groupBy_6__ResultContainerD_')  # <ResultContainerD_>
    _groupBy_6__ResultD_ = typing.TypeVar('_groupBy_6__ResultD_')  # <ResultD_>
    _groupBy_7__ResultContainerA_ = typing.TypeVar('_groupBy_7__ResultContainerA_')  # <ResultContainerA_>
    _groupBy_7__ResultA_ = typing.TypeVar('_groupBy_7__ResultA_')  # <ResultA_>
    _groupBy_7__ResultContainerB_ = typing.TypeVar('_groupBy_7__ResultContainerB_')  # <ResultContainerB_>
    _groupBy_7__ResultB_ = typing.TypeVar('_groupBy_7__ResultB_')  # <ResultB_>
    _groupBy_7__ResultContainerC_ = typing.TypeVar('_groupBy_7__ResultContainerC_')  # <ResultContainerC_>
    _groupBy_7__ResultC_ = typing.TypeVar('_groupBy_7__ResultC_')  # <ResultC_>
    _groupBy_7__ResultContainerD_ = typing.TypeVar('_groupBy_7__ResultContainerD_')  # <ResultContainerD_>
    _groupBy_7__ResultD_ = typing.TypeVar('_groupBy_7__ResultD_')  # <ResultD_>
    _groupBy_8__GroupKeyA_ = typing.TypeVar('_groupBy_8__GroupKeyA_')  # <GroupKeyA_>
    _groupBy_8__GroupKeyB_ = typing.TypeVar('_groupBy_8__GroupKeyB_')  # <GroupKeyB_>
    _groupBy_8__GroupKeyC_ = typing.TypeVar('_groupBy_8__GroupKeyC_')  # <GroupKeyC_>
    _groupBy_9__GroupKeyA_ = typing.TypeVar('_groupBy_9__GroupKeyA_')  # <GroupKeyA_>
    _groupBy_9__GroupKeyB_ = typing.TypeVar('_groupBy_9__GroupKeyB_')  # <GroupKeyB_>
    _groupBy_9__ResultContainer_ = typing.TypeVar('_groupBy_9__ResultContainer_')  # <ResultContainer_>
    _groupBy_9__Result_ = typing.TypeVar('_groupBy_9__Result_')  # <Result_>
    _groupBy_10__GroupKey_ = typing.TypeVar('_groupBy_10__GroupKey_')  # <GroupKey_>
    _groupBy_10__ResultContainerB_ = typing.TypeVar('_groupBy_10__ResultContainerB_')  # <ResultContainerB_>
    _groupBy_10__ResultB_ = typing.TypeVar('_groupBy_10__ResultB_')  # <ResultB_>
    _groupBy_10__ResultContainerC_ = typing.TypeVar('_groupBy_10__ResultContainerC_')  # <ResultContainerC_>
    _groupBy_10__ResultC_ = typing.TypeVar('_groupBy_10__ResultC_')  # <ResultC_>
    _groupBy_11__ResultContainerA_ = typing.TypeVar('_groupBy_11__ResultContainerA_')  # <ResultContainerA_>
    _groupBy_11__ResultA_ = typing.TypeVar('_groupBy_11__ResultA_')  # <ResultA_>
    _groupBy_11__ResultContainerB_ = typing.TypeVar('_groupBy_11__ResultContainerB_')  # <ResultContainerB_>
    _groupBy_11__ResultB_ = typing.TypeVar('_groupBy_11__ResultB_')  # <ResultB_>
    _groupBy_11__ResultContainerC_ = typing.TypeVar('_groupBy_11__ResultContainerC_')  # <ResultContainerC_>
    _groupBy_11__ResultC_ = typing.TypeVar('_groupBy_11__ResultC_')  # <ResultC_>
    _groupBy_12__GroupKey_ = typing.TypeVar('_groupBy_12__GroupKey_')  # <GroupKey_>
    _groupBy_13__ResultContainer_ = typing.TypeVar('_groupBy_13__ResultContainer_')  # <ResultContainer_>
    _groupBy_13__Result_ = typing.TypeVar('_groupBy_13__Result_')  # <Result_>
    @typing.overload
    def groupBy(self, triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_0__GroupKeyA_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_0__GroupKeyA_]], triFunction2: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_0__GroupKeyB_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_0__GroupKeyB_]]) -> org.optaplanner.core.api.score.stream.bi.BiConstraintStream[_groupBy_0__GroupKeyA_, _groupBy_0__GroupKeyB_]: ...
    @typing.overload
    def groupBy(self, triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_1__GroupKey_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_1__GroupKey_]], triConstraintCollector: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_1__ResultContainer_, _groupBy_1__Result_]) -> org.optaplanner.core.api.score.stream.bi.BiConstraintStream[_groupBy_1__GroupKey_, _groupBy_1__Result_]: ...
    @typing.overload
    def groupBy(self, triConstraintCollector: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_2__ResultContainerA_, _groupBy_2__ResultA_], triConstraintCollector2: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_2__ResultContainerB_, _groupBy_2__ResultB_]) -> org.optaplanner.core.api.score.stream.bi.BiConstraintStream[_groupBy_2__ResultA_, _groupBy_2__ResultB_]: ...
    @typing.overload
    def groupBy(self, triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_3__GroupKeyA_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_3__GroupKeyA_]], triFunction2: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_3__GroupKeyB_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_3__GroupKeyB_]], triFunction3: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_3__GroupKeyC_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_3__GroupKeyC_]], triFunction4: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_3__GroupKeyD_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_3__GroupKeyD_]]) -> org.optaplanner.core.api.score.stream.quad.QuadConstraintStream[_groupBy_3__GroupKeyA_, _groupBy_3__GroupKeyB_, _groupBy_3__GroupKeyC_, _groupBy_3__GroupKeyD_]: ...
    @typing.overload
    def groupBy(self, triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_4__GroupKeyA_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_4__GroupKeyA_]], triFunction2: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_4__GroupKeyB_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_4__GroupKeyB_]], triFunction3: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_4__GroupKeyC_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_4__GroupKeyC_]], triConstraintCollector: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_4__ResultContainerD_, _groupBy_4__ResultD_]) -> org.optaplanner.core.api.score.stream.quad.QuadConstraintStream[_groupBy_4__GroupKeyA_, _groupBy_4__GroupKeyB_, _groupBy_4__GroupKeyC_, _groupBy_4__ResultD_]: ...
    @typing.overload
    def groupBy(self, triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_5__GroupKeyA_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_5__GroupKeyA_]], triFunction2: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_5__GroupKeyB_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_5__GroupKeyB_]], triConstraintCollector: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_5__ResultContainerC_, _groupBy_5__ResultC_], triConstraintCollector2: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_5__ResultContainerD_, _groupBy_5__ResultD_]) -> org.optaplanner.core.api.score.stream.quad.QuadConstraintStream[_groupBy_5__GroupKeyA_, _groupBy_5__GroupKeyB_, _groupBy_5__ResultC_, _groupBy_5__ResultD_]: ...
    @typing.overload
    def groupBy(self, triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_6__GroupKey_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_6__GroupKey_]], triConstraintCollector: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_6__ResultContainerB_, _groupBy_6__ResultB_], triConstraintCollector2: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_6__ResultContainerC_, _groupBy_6__ResultC_], triConstraintCollector3: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_6__ResultContainerD_, _groupBy_6__ResultD_]) -> org.optaplanner.core.api.score.stream.quad.QuadConstraintStream[_groupBy_6__GroupKey_, _groupBy_6__ResultB_, _groupBy_6__ResultC_, _groupBy_6__ResultD_]: ...
    @typing.overload
    def groupBy(self, triConstraintCollector: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_7__ResultContainerA_, _groupBy_7__ResultA_], triConstraintCollector2: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_7__ResultContainerB_, _groupBy_7__ResultB_], triConstraintCollector3: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_7__ResultContainerC_, _groupBy_7__ResultC_], triConstraintCollector4: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_7__ResultContainerD_, _groupBy_7__ResultD_]) -> org.optaplanner.core.api.score.stream.quad.QuadConstraintStream[_groupBy_7__ResultA_, _groupBy_7__ResultB_, _groupBy_7__ResultC_, _groupBy_7__ResultD_]: ...
    @typing.overload
    def groupBy(self, triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_8__GroupKeyA_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_8__GroupKeyA_]], triFunction2: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_8__GroupKeyB_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_8__GroupKeyB_]], triFunction3: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_8__GroupKeyC_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_8__GroupKeyC_]]) -> 'TriConstraintStream'[_groupBy_8__GroupKeyA_, _groupBy_8__GroupKeyB_, _groupBy_8__GroupKeyC_]: ...
    @typing.overload
    def groupBy(self, triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_9__GroupKeyA_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_9__GroupKeyA_]], triFunction2: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_9__GroupKeyB_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_9__GroupKeyB_]], triConstraintCollector: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_9__ResultContainer_, _groupBy_9__Result_]) -> 'TriConstraintStream'[_groupBy_9__GroupKeyA_, _groupBy_9__GroupKeyB_, _groupBy_9__Result_]: ...
    @typing.overload
    def groupBy(self, triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_10__GroupKey_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_10__GroupKey_]], triConstraintCollector: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_10__ResultContainerB_, _groupBy_10__ResultB_], triConstraintCollector2: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_10__ResultContainerC_, _groupBy_10__ResultC_]) -> 'TriConstraintStream'[_groupBy_10__GroupKey_, _groupBy_10__ResultB_, _groupBy_10__ResultC_]: ...
    @typing.overload
    def groupBy(self, triConstraintCollector: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_11__ResultContainerA_, _groupBy_11__ResultA_], triConstraintCollector2: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_11__ResultContainerB_, _groupBy_11__ResultB_], triConstraintCollector3: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_11__ResultContainerC_, _groupBy_11__ResultC_]) -> 'TriConstraintStream'[_groupBy_11__ResultA_, _groupBy_11__ResultB_, _groupBy_11__ResultC_]: ...
    @typing.overload
    def groupBy(self, triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_12__GroupKey_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _groupBy_12__GroupKey_]]) -> org.optaplanner.core.api.score.stream.uni.UniConstraintStream[_groupBy_12__GroupKey_]: ...
    @typing.overload
    def groupBy(self, triConstraintCollector: TriConstraintCollector[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _groupBy_13__ResultContainer_, _groupBy_13__Result_]) -> org.optaplanner.core.api.score.stream.uni.UniConstraintStream[_groupBy_13__Result_]: ...
    _ifExists_0__D = typing.TypeVar('_ifExists_0__D')  # <D>
    _ifExists_1__D = typing.TypeVar('_ifExists_1__D')  # <D>
    _ifExists_2__D = typing.TypeVar('_ifExists_2__D')  # <D>
    _ifExists_3__D = typing.TypeVar('_ifExists_3__D')  # <D>
    _ifExists_4__D = typing.TypeVar('_ifExists_4__D')  # <D>
    @typing.overload
    def ifExists(self, class_: typing.Type[_ifExists_0__D], quadJoinerArray: typing.List[org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExists_0__D]]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    @typing.overload
    def ifExists(self, class_: typing.Type[_ifExists_1__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExists_1__D]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    @typing.overload
    def ifExists(self, class_: typing.Type[_ifExists_2__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExists_2__D], quadJoiner2: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExists_2__D]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    @typing.overload
    def ifExists(self, class_: typing.Type[_ifExists_3__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExists_3__D], quadJoiner2: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExists_3__D], quadJoiner3: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExists_3__D]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    @typing.overload
    def ifExists(self, class_: typing.Type[_ifExists_4__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExists_4__D], quadJoiner2: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExists_4__D], quadJoiner3: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExists_4__D], quadJoiner4: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExists_4__D]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    _ifExistsIncludingNullVars_0__D = typing.TypeVar('_ifExistsIncludingNullVars_0__D')  # <D>
    _ifExistsIncludingNullVars_1__D = typing.TypeVar('_ifExistsIncludingNullVars_1__D')  # <D>
    _ifExistsIncludingNullVars_2__D = typing.TypeVar('_ifExistsIncludingNullVars_2__D')  # <D>
    _ifExistsIncludingNullVars_3__D = typing.TypeVar('_ifExistsIncludingNullVars_3__D')  # <D>
    _ifExistsIncludingNullVars_4__D = typing.TypeVar('_ifExistsIncludingNullVars_4__D')  # <D>
    @typing.overload
    def ifExistsIncludingNullVars(self, class_: typing.Type[_ifExistsIncludingNullVars_0__D], quadJoinerArray: typing.List[org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExistsIncludingNullVars_0__D]]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    @typing.overload
    def ifExistsIncludingNullVars(self, class_: typing.Type[_ifExistsIncludingNullVars_1__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExistsIncludingNullVars_1__D]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    @typing.overload
    def ifExistsIncludingNullVars(self, class_: typing.Type[_ifExistsIncludingNullVars_2__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExistsIncludingNullVars_2__D], quadJoiner2: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExistsIncludingNullVars_2__D]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    @typing.overload
    def ifExistsIncludingNullVars(self, class_: typing.Type[_ifExistsIncludingNullVars_3__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExistsIncludingNullVars_3__D], quadJoiner2: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExistsIncludingNullVars_3__D], quadJoiner3: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExistsIncludingNullVars_3__D]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    @typing.overload
    def ifExistsIncludingNullVars(self, class_: typing.Type[_ifExistsIncludingNullVars_4__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExistsIncludingNullVars_4__D], quadJoiner2: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExistsIncludingNullVars_4__D], quadJoiner3: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExistsIncludingNullVars_4__D], quadJoiner4: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifExistsIncludingNullVars_4__D]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    _ifNotExists_0__D = typing.TypeVar('_ifNotExists_0__D')  # <D>
    _ifNotExists_1__D = typing.TypeVar('_ifNotExists_1__D')  # <D>
    _ifNotExists_2__D = typing.TypeVar('_ifNotExists_2__D')  # <D>
    _ifNotExists_3__D = typing.TypeVar('_ifNotExists_3__D')  # <D>
    _ifNotExists_4__D = typing.TypeVar('_ifNotExists_4__D')  # <D>
    @typing.overload
    def ifNotExists(self, class_: typing.Type[_ifNotExists_0__D], quadJoinerArray: typing.List[org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExists_0__D]]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    @typing.overload
    def ifNotExists(self, class_: typing.Type[_ifNotExists_1__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExists_1__D]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    @typing.overload
    def ifNotExists(self, class_: typing.Type[_ifNotExists_2__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExists_2__D], quadJoiner2: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExists_2__D]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    @typing.overload
    def ifNotExists(self, class_: typing.Type[_ifNotExists_3__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExists_3__D], quadJoiner2: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExists_3__D], quadJoiner3: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExists_3__D]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    @typing.overload
    def ifNotExists(self, class_: typing.Type[_ifNotExists_4__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExists_4__D], quadJoiner2: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExists_4__D], quadJoiner3: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExists_4__D], quadJoiner4: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExists_4__D]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    _ifNotExistsIncludingNullVars_0__D = typing.TypeVar('_ifNotExistsIncludingNullVars_0__D')  # <D>
    _ifNotExistsIncludingNullVars_1__D = typing.TypeVar('_ifNotExistsIncludingNullVars_1__D')  # <D>
    _ifNotExistsIncludingNullVars_2__D = typing.TypeVar('_ifNotExistsIncludingNullVars_2__D')  # <D>
    _ifNotExistsIncludingNullVars_3__D = typing.TypeVar('_ifNotExistsIncludingNullVars_3__D')  # <D>
    _ifNotExistsIncludingNullVars_4__D = typing.TypeVar('_ifNotExistsIncludingNullVars_4__D')  # <D>
    @typing.overload
    def ifNotExistsIncludingNullVars(self, class_: typing.Type[_ifNotExistsIncludingNullVars_0__D], quadJoinerArray: typing.List[org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExistsIncludingNullVars_0__D]]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    @typing.overload
    def ifNotExistsIncludingNullVars(self, class_: typing.Type[_ifNotExistsIncludingNullVars_1__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExistsIncludingNullVars_1__D]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    @typing.overload
    def ifNotExistsIncludingNullVars(self, class_: typing.Type[_ifNotExistsIncludingNullVars_2__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExistsIncludingNullVars_2__D], quadJoiner2: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExistsIncludingNullVars_2__D]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    @typing.overload
    def ifNotExistsIncludingNullVars(self, class_: typing.Type[_ifNotExistsIncludingNullVars_3__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExistsIncludingNullVars_3__D], quadJoiner2: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExistsIncludingNullVars_3__D], quadJoiner3: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExistsIncludingNullVars_3__D]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    @typing.overload
    def ifNotExistsIncludingNullVars(self, class_: typing.Type[_ifNotExistsIncludingNullVars_4__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExistsIncludingNullVars_4__D], quadJoiner2: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExistsIncludingNullVars_4__D], quadJoiner3: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExistsIncludingNullVars_4__D], quadJoiner4: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _ifNotExistsIncludingNullVars_4__D]) -> 'TriConstraintStream'[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C]: ...
    @typing.overload
    def impact(self, string: str, string2: str, score: org.optaplanner.core.api.score.Score[typing.Any]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def impact(self, string: str, string2: str, score: org.optaplanner.core.api.score.Score[typing.Any], toIntTriFunction: typing.Union[org.optaplanner.core.api.function.ToIntTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def impact(self, string: str, score: org.optaplanner.core.api.score.Score[typing.Any]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def impact(self, string: str, score: org.optaplanner.core.api.score.Score[typing.Any], toIntTriFunction: typing.Union[org.optaplanner.core.api.function.ToIntTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def impactBigDecimal(self, string: str, string2: str, score: org.optaplanner.core.api.score.Score[typing.Any], triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, typing.Union[java.math.BigDecimal, decimal.Decimal]], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Union[java.math.BigDecimal, decimal.Decimal]]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def impactBigDecimal(self, string: str, score: org.optaplanner.core.api.score.Score[typing.Any], triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, typing.Union[java.math.BigDecimal, decimal.Decimal]], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Union[java.math.BigDecimal, decimal.Decimal]]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def impactConfigurable(self, string: str, string2: str, toIntTriFunction: typing.Union[org.optaplanner.core.api.function.ToIntTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def impactConfigurable(self, string: str, toIntTriFunction: typing.Union[org.optaplanner.core.api.function.ToIntTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def impactConfigurableBigDecimal(self, string: str, string2: str, triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, typing.Union[java.math.BigDecimal, decimal.Decimal]], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Union[java.math.BigDecimal, decimal.Decimal]]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def impactConfigurableBigDecimal(self, string: str, triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, typing.Union[java.math.BigDecimal, decimal.Decimal]], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Union[java.math.BigDecimal, decimal.Decimal]]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def impactConfigurableLong(self, string: str, string2: str, toLongTriFunction: typing.Union[org.optaplanner.core.api.function.ToLongTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def impactConfigurableLong(self, string: str, toLongTriFunction: typing.Union[org.optaplanner.core.api.function.ToLongTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def impactLong(self, string: str, string2: str, score: org.optaplanner.core.api.score.Score[typing.Any], toLongTriFunction: typing.Union[org.optaplanner.core.api.function.ToLongTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def impactLong(self, string: str, score: org.optaplanner.core.api.score.Score[typing.Any], toLongTriFunction: typing.Union[org.optaplanner.core.api.function.ToLongTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    _join_0__D = typing.TypeVar('_join_0__D')  # <D>
    _join_1__D = typing.TypeVar('_join_1__D')  # <D>
    _join_2__D = typing.TypeVar('_join_2__D')  # <D>
    _join_3__D = typing.TypeVar('_join_3__D')  # <D>
    _join_4__D = typing.TypeVar('_join_4__D')  # <D>
    _join_5__D = typing.TypeVar('_join_5__D')  # <D>
    _join_6__D = typing.TypeVar('_join_6__D')  # <D>
    _join_7__D = typing.TypeVar('_join_7__D')  # <D>
    _join_8__D = typing.TypeVar('_join_8__D')  # <D>
    _join_9__D = typing.TypeVar('_join_9__D')  # <D>
    _join_10__D = typing.TypeVar('_join_10__D')  # <D>
    _join_11__D = typing.TypeVar('_join_11__D')  # <D>
    @typing.overload
    def join(self, class_: typing.Type[_join_0__D], quadJoinerArray: typing.List[org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_0__D]]) -> org.optaplanner.core.api.score.stream.quad.QuadConstraintStream[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_0__D]: ...
    @typing.overload
    def join(self, uniConstraintStream: org.optaplanner.core.api.score.stream.uni.UniConstraintStream[_join_1__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_1__D]) -> org.optaplanner.core.api.score.stream.quad.QuadConstraintStream[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_1__D]: ...
    @typing.overload
    def join(self, uniConstraintStream: org.optaplanner.core.api.score.stream.uni.UniConstraintStream[_join_2__D], quadJoinerArray: typing.List[org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_2__D]]) -> org.optaplanner.core.api.score.stream.quad.QuadConstraintStream[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_2__D]: ...
    @typing.overload
    def join(self, class_: typing.Type[_join_3__D]) -> org.optaplanner.core.api.score.stream.quad.QuadConstraintStream[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_3__D]: ...
    @typing.overload
    def join(self, class_: typing.Type[_join_4__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_4__D]) -> org.optaplanner.core.api.score.stream.quad.QuadConstraintStream[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_4__D]: ...
    @typing.overload
    def join(self, class_: typing.Type[_join_5__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_5__D], quadJoiner2: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_5__D]) -> org.optaplanner.core.api.score.stream.quad.QuadConstraintStream[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_5__D]: ...
    @typing.overload
    def join(self, class_: typing.Type[_join_6__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_6__D], quadJoiner2: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_6__D], quadJoiner3: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_6__D]) -> org.optaplanner.core.api.score.stream.quad.QuadConstraintStream[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_6__D]: ...
    @typing.overload
    def join(self, class_: typing.Type[_join_7__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_7__D], quadJoiner2: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_7__D], quadJoiner3: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_7__D], quadJoiner4: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_7__D]) -> org.optaplanner.core.api.score.stream.quad.QuadConstraintStream[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_7__D]: ...
    @typing.overload
    def join(self, uniConstraintStream: org.optaplanner.core.api.score.stream.uni.UniConstraintStream[_join_8__D]) -> org.optaplanner.core.api.score.stream.quad.QuadConstraintStream[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_8__D]: ...
    @typing.overload
    def join(self, uniConstraintStream: org.optaplanner.core.api.score.stream.uni.UniConstraintStream[_join_9__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_9__D], quadJoiner2: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_9__D]) -> org.optaplanner.core.api.score.stream.quad.QuadConstraintStream[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_9__D]: ...
    @typing.overload
    def join(self, uniConstraintStream: org.optaplanner.core.api.score.stream.uni.UniConstraintStream[_join_10__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_10__D], quadJoiner2: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_10__D], quadJoiner3: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_10__D]) -> org.optaplanner.core.api.score.stream.quad.QuadConstraintStream[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_10__D]: ...
    @typing.overload
    def join(self, uniConstraintStream: org.optaplanner.core.api.score.stream.uni.UniConstraintStream[_join_11__D], quadJoiner: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_11__D], quadJoiner2: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_11__D], quadJoiner3: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_11__D], quadJoiner4: org.optaplanner.core.api.score.stream.quad.QuadJoiner[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_11__D]) -> org.optaplanner.core.api.score.stream.quad.QuadConstraintStream[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _join_11__D]: ...
    _map__ResultA_ = typing.TypeVar('_map__ResultA_')  # <ResultA_>
    def map(self, triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, _map__ResultA_], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], _map__ResultA_]]) -> org.optaplanner.core.api.score.stream.uni.UniConstraintStream[_map__ResultA_]: ...
    @typing.overload
    def penalize(self, string: str, string2: str, score: org.optaplanner.core.api.score.Score[typing.Any]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def penalize(self, string: str, string2: str, score: org.optaplanner.core.api.score.Score[typing.Any], toIntTriFunction: typing.Union[org.optaplanner.core.api.function.ToIntTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def penalize(self, string: str, score: org.optaplanner.core.api.score.Score[typing.Any]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def penalize(self, string: str, score: org.optaplanner.core.api.score.Score[typing.Any], toIntTriFunction: typing.Union[org.optaplanner.core.api.function.ToIntTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def penalizeBigDecimal(self, string: str, string2: str, score: org.optaplanner.core.api.score.Score[typing.Any], triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, typing.Union[java.math.BigDecimal, decimal.Decimal]], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Union[java.math.BigDecimal, decimal.Decimal]]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def penalizeBigDecimal(self, string: str, score: org.optaplanner.core.api.score.Score[typing.Any], triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, typing.Union[java.math.BigDecimal, decimal.Decimal]], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Union[java.math.BigDecimal, decimal.Decimal]]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def penalizeConfigurable(self, string: str, string2: str) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def penalizeConfigurable(self, string: str, string2: str, toIntTriFunction: typing.Union[org.optaplanner.core.api.function.ToIntTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def penalizeConfigurable(self, string: str) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def penalizeConfigurable(self, string: str, toIntTriFunction: typing.Union[org.optaplanner.core.api.function.ToIntTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def penalizeConfigurableBigDecimal(self, string: str, string2: str, triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, typing.Union[java.math.BigDecimal, decimal.Decimal]], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Union[java.math.BigDecimal, decimal.Decimal]]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def penalizeConfigurableBigDecimal(self, string: str, triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, typing.Union[java.math.BigDecimal, decimal.Decimal]], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Union[java.math.BigDecimal, decimal.Decimal]]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def penalizeConfigurableLong(self, string: str, string2: str, toLongTriFunction: typing.Union[org.optaplanner.core.api.function.ToLongTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def penalizeConfigurableLong(self, string: str, toLongTriFunction: typing.Union[org.optaplanner.core.api.function.ToLongTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def penalizeLong(self, string: str, string2: str, score: org.optaplanner.core.api.score.Score[typing.Any], toLongTriFunction: typing.Union[org.optaplanner.core.api.function.ToLongTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def penalizeLong(self, string: str, score: org.optaplanner.core.api.score.Score[typing.Any], toLongTriFunction: typing.Union[org.optaplanner.core.api.function.ToLongTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def reward(self, string: str, string2: str, score: org.optaplanner.core.api.score.Score[typing.Any]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def reward(self, string: str, string2: str, score: org.optaplanner.core.api.score.Score[typing.Any], toIntTriFunction: typing.Union[org.optaplanner.core.api.function.ToIntTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def reward(self, string: str, score: org.optaplanner.core.api.score.Score[typing.Any]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def reward(self, string: str, score: org.optaplanner.core.api.score.Score[typing.Any], toIntTriFunction: typing.Union[org.optaplanner.core.api.function.ToIntTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def rewardBigDecimal(self, string: str, string2: str, score: org.optaplanner.core.api.score.Score[typing.Any], triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, typing.Union[java.math.BigDecimal, decimal.Decimal]], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Union[java.math.BigDecimal, decimal.Decimal]]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def rewardBigDecimal(self, string: str, score: org.optaplanner.core.api.score.Score[typing.Any], triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, typing.Union[java.math.BigDecimal, decimal.Decimal]], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Union[java.math.BigDecimal, decimal.Decimal]]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def rewardConfigurable(self, string: str, string2: str) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def rewardConfigurable(self, string: str, string2: str, toIntTriFunction: typing.Union[org.optaplanner.core.api.function.ToIntTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def rewardConfigurable(self, string: str) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def rewardConfigurable(self, string: str, toIntTriFunction: typing.Union[org.optaplanner.core.api.function.ToIntTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def rewardConfigurableBigDecimal(self, string: str, string2: str, triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, typing.Union[java.math.BigDecimal, decimal.Decimal]], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Union[java.math.BigDecimal, decimal.Decimal]]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def rewardConfigurableBigDecimal(self, string: str, triFunction: typing.Union[org.optaplanner.core.api.function.TriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C, typing.Union[java.math.BigDecimal, decimal.Decimal]], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Union[java.math.BigDecimal, decimal.Decimal]]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def rewardConfigurableLong(self, string: str, string2: str, toLongTriFunction: typing.Union[org.optaplanner.core.api.function.ToLongTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def rewardConfigurableLong(self, string: str, toLongTriFunction: typing.Union[org.optaplanner.core.api.function.ToLongTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def rewardLong(self, string: str, string2: str, score: org.optaplanner.core.api.score.Score[typing.Any], toLongTriFunction: typing.Union[org.optaplanner.core.api.function.ToLongTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...
    @typing.overload
    def rewardLong(self, string: str, score: org.optaplanner.core.api.score.Score[typing.Any], toLongTriFunction: typing.Union[org.optaplanner.core.api.function.ToLongTriFunction[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], typing.Callable[[_TriConstraintStream__A, _TriConstraintStream__B, _TriConstraintStream__C], int]]) -> org.optaplanner.core.api.score.stream.Constraint: ...

_TriJoiner__A = typing.TypeVar('_TriJoiner__A')  # <A>
_TriJoiner__B = typing.TypeVar('_TriJoiner__B')  # <B>
_TriJoiner__C = typing.TypeVar('_TriJoiner__C')  # <C>
class TriJoiner(typing.Generic[_TriJoiner__A, _TriJoiner__B, _TriJoiner__C]):
    """
    public interface TriJoiner<A, B, C>
    
        Created with :class:`~org.optaplanner.core.api.score.stream.Joiners`. Used by
        :meth:`~org.optaplanner.core.api.score.stream.bi.BiConstraintStream.join`, ...
    
        Also see:
            :class:`~org.optaplanner.core.api.score.stream.Joiners`
    """
    ...


class __module_protocol__(typing.Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("org.optaplanner.core.api.score.stream.tri")``.

    TriConstraintCollector: typing.Type[TriConstraintCollector]
    TriConstraintStream: typing.Type[TriConstraintStream]
    TriJoiner: typing.Type[TriJoiner]
