import java.lang
import java.util.function
import org.optaplanner.core.config
import org.optaplanner.core.impl.localsearch.decider.forager.finalist
import typing



class FinalistPodiumType(java.lang.Enum['FinalistPodiumType']):
    """
    public enum FinalistPodiumType extends :class:`~org.optaplanner.core.config.localsearch.decider.forager.https:.docs.oracle.com.javase.8.docs.api.java.lang.Enum?is`<:class:`~org.optaplanner.core.config.localsearch.decider.forager.FinalistPodiumType`>
    """
    HIGHEST_SCORE: typing.ClassVar['FinalistPodiumType'] = ...
    STRATEGIC_OSCILLATION: typing.ClassVar['FinalistPodiumType'] = ...
    STRATEGIC_OSCILLATION_BY_LEVEL: typing.ClassVar['FinalistPodiumType'] = ...
    STRATEGIC_OSCILLATION_BY_LEVEL_ON_BEST_SCORE: typing.ClassVar['FinalistPodiumType'] = ...
    _buildFinalistPodium__Solution_ = typing.TypeVar('_buildFinalistPodium__Solution_')  # <Solution_>
    def buildFinalistPodium(self) -> org.optaplanner.core.impl.localsearch.decider.forager.finalist.FinalistPodium[_buildFinalistPodium__Solution_]: ...
    _valueOf_0__T = typing.TypeVar('_valueOf_0__T', bound=java.lang.Enum)  # <T>
    @typing.overload
    @staticmethod
    def valueOf(class_: typing.Type[_valueOf_0__T], string: str) -> _valueOf_0__T: ...
    @typing.overload
    @staticmethod
    def valueOf(string: str) -> 'FinalistPodiumType':
        """
            Returns the enum constant of this type with the specified name. The string must match *exactly* an identifier used to
            declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
        
            Parameters:
                name (:class:`~org.optaplanner.core.config.localsearch.decider.forager.https:.docs.oracle.com.javase.8.docs.api.java.lang.String?is`): the name of the enum constant to be returned.
        
            Returns:
                the enum constant with the specified name
        
            Raises:
                :class:`~org.optaplanner.core.config.localsearch.decider.forager.https:.docs.oracle.com.javase.8.docs.api.java.lang.IllegalArgumentException?is`: if this enum type has no constant with the specified name
                :class:`~org.optaplanner.core.config.localsearch.decider.forager.https:.docs.oracle.com.javase.8.docs.api.java.lang.NullPointerException?is`: if the argument is null
        
        
        """
        ...
    @staticmethod
    def values() -> typing.List['FinalistPodiumType']:
        """
            Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to
            iterate over the constants as follows:
        
            .. code-block: java
            
            for (FinalistPodiumType c : FinalistPodiumType.values())
                System.out.println(c);
            
        
            Returns:
                an array containing the constants of this enum type, in the order they are declared
        
        
        """
        ...

class LocalSearchForagerConfig(org.optaplanner.core.config.AbstractConfig['LocalSearchForagerConfig']):
    """
    public class LocalSearchForagerConfig extends :class:`~org.optaplanner.core.config.AbstractConfig`<:class:`~org.optaplanner.core.config.localsearch.decider.forager.LocalSearchForagerConfig`>
    """
    def __init__(self): ...
    def copyConfig(self) -> 'LocalSearchForagerConfig':
        """
            Description copied from class: :meth:`~org.optaplanner.core.config.AbstractConfig.copyConfig`
            Typically implemented by constructing a new instance and calling
            :meth:`~org.optaplanner.core.config.AbstractConfig.inherit` on it
        
            Specified by:
                :meth:`~org.optaplanner.core.config.AbstractConfig.copyConfig` in
                class :class:`~org.optaplanner.core.config.AbstractConfig`
        
            Returns:
                new instance
        
        
        """
        ...
    def getAcceptedCountLimit(self) -> int: ...
    def getBreakTieRandomly(self) -> bool: ...
    def getFinalistPodiumType(self) -> FinalistPodiumType: ...
    def getPickEarlyType(self) -> 'LocalSearchPickEarlyType': ...
    def inherit(self, localSearchForagerConfig: 'LocalSearchForagerConfig') -> 'LocalSearchForagerConfig':
        """
            Description copied from class: :meth:`~org.optaplanner.core.config.AbstractConfig.inherit`
            Inherits each property of the :code:`inheritedConfig` unless that property (or a semantic alternative) is defined by
            this instance (which overwrites the inherited behaviour).
        
            After the inheritance, if a property on this :class:`~org.optaplanner.core.config.AbstractConfig` composition is
            replaced, it should not affect the inherited composition instance.
        
            Specified by:
                :meth:`~org.optaplanner.core.config.AbstractConfig.inherit` in
                class :class:`~org.optaplanner.core.config.AbstractConfig`
        
            Parameters:
                inheritedConfig (:class:`~org.optaplanner.core.config.localsearch.decider.forager.LocalSearchForagerConfig`): never null
        
            Returns:
                this
        
        
        """
        ...
    def setAcceptedCountLimit(self, integer: int) -> None: ...
    def setBreakTieRandomly(self, boolean: bool) -> None: ...
    def setFinalistPodiumType(self, finalistPodiumType: FinalistPodiumType) -> None: ...
    def setPickEarlyType(self, localSearchPickEarlyType: 'LocalSearchPickEarlyType') -> None: ...
    def visitReferencedClasses(self, consumer: typing.Union[java.util.function.Consumer[typing.Type[typing.Any]], typing.Callable[[typing.Type[typing.Any]], None]]) -> None: ...
    def withAcceptedCountLimit(self, int: int) -> 'LocalSearchForagerConfig': ...
    def withBreakTieRandomly(self, boolean: bool) -> 'LocalSearchForagerConfig': ...
    def withFinalistPodiumType(self, finalistPodiumType: FinalistPodiumType) -> 'LocalSearchForagerConfig': ...
    def withPickEarlyType(self, localSearchPickEarlyType: 'LocalSearchPickEarlyType') -> 'LocalSearchForagerConfig': ...

class LocalSearchPickEarlyType(java.lang.Enum['LocalSearchPickEarlyType']):
    """
    public enum LocalSearchPickEarlyType extends :class:`~org.optaplanner.core.config.localsearch.decider.forager.https:.docs.oracle.com.javase.8.docs.api.java.lang.Enum?is`<:class:`~org.optaplanner.core.config.localsearch.decider.forager.LocalSearchPickEarlyType`>
    """
    NEVER: typing.ClassVar['LocalSearchPickEarlyType'] = ...
    FIRST_BEST_SCORE_IMPROVING: typing.ClassVar['LocalSearchPickEarlyType'] = ...
    FIRST_LAST_STEP_SCORE_IMPROVING: typing.ClassVar['LocalSearchPickEarlyType'] = ...
    _valueOf_0__T = typing.TypeVar('_valueOf_0__T', bound=java.lang.Enum)  # <T>
    @typing.overload
    @staticmethod
    def valueOf(class_: typing.Type[_valueOf_0__T], string: str) -> _valueOf_0__T: ...
    @typing.overload
    @staticmethod
    def valueOf(string: str) -> 'LocalSearchPickEarlyType':
        """
            Returns the enum constant of this type with the specified name. The string must match *exactly* an identifier used to
            declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
        
            Parameters:
                name (:class:`~org.optaplanner.core.config.localsearch.decider.forager.https:.docs.oracle.com.javase.8.docs.api.java.lang.String?is`): the name of the enum constant to be returned.
        
            Returns:
                the enum constant with the specified name
        
            Raises:
                :class:`~org.optaplanner.core.config.localsearch.decider.forager.https:.docs.oracle.com.javase.8.docs.api.java.lang.IllegalArgumentException?is`: if this enum type has no constant with the specified name
                :class:`~org.optaplanner.core.config.localsearch.decider.forager.https:.docs.oracle.com.javase.8.docs.api.java.lang.NullPointerException?is`: if the argument is null
        
        
        """
        ...
    @staticmethod
    def values() -> typing.List['LocalSearchPickEarlyType']:
        """
            Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to
            iterate over the constants as follows:
        
            .. code-block: java
            
            for (LocalSearchPickEarlyType c : LocalSearchPickEarlyType.values())
                System.out.println(c);
            
        
            Returns:
                an array containing the constants of this enum type, in the order they are declared
        
        
        """
        ...


class __module_protocol__(typing.Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("org.optaplanner.core.config.localsearch.decider.forager")``.

    FinalistPodiumType: typing.Type[FinalistPodiumType]
    LocalSearchForagerConfig: typing.Type[LocalSearchForagerConfig]
    LocalSearchPickEarlyType: typing.Type[LocalSearchPickEarlyType]
